############################################################################
#                                                                          #
# A steel mill produces sheets of steel in different sizes. How should the #
# mill cut the sheets in the user-required sizes while minimizing waste?   #
#                                                                          #
############################################################################

set DEMANDED_SIZES;
set COMBINATIONS;

##############
# Parameters #
##############

param DEMAND {DEMANDED_SIZES};                      # Demand per sheet
param WASTE {COMBINATIONS};                         # Waste per combination
param CUT_DECISIONS {COMBINATIONS,DEMANDED_SIZES};  # Number of sizes per cut

#############
# Variables #
#############

var NUMBER_OF_COMBINATIONS {COMBINATIONS} >=0,integer; # Number of sheets 

#########
# Model #
#########

minimize TOTAL_WASTE:
   sum {i in COMBINATIONS} WASTE[i]*NUMBER_OF_COMBINATIONS[i];
subject to
   Demand {j in DEMANDED_SIZES}:
      sum {i in COMBINATIONS} CUT_DECISIONS[i,j]*NUMBER_OF_COMBINATIONS[i]
                              = DEMAND[j];

