###########################################################################
#                                                                         #
# Your company manufactures several products, using a common parts        #
# inventory of different parts. Parts are in limited supply and you must  #
# determine the most profitable mix of products to build.                 #
#                                                                         #
###########################################################################

set PARTS;
set PRODUCTS;

##############
# Parameters #
##############

param INVENTORY {PARTS};                # Number of available parts
param NECESSARY {PARTS,PRODUCTS};       # Number of parts needed for product
param PROFIT {PRODUCTS};                # Profit made on each product

#############
# Variables #
#############

var NUMBER_TO_BUILD {PRODUCTS} >=0;     # Number of products to make

#########
# Model #
#########

maximize TOTAL_PROFIT:
   sum {j in PRODUCTS} NUMBER_TO_BUILD[j]*PROFIT[j];
subject to
   Limit_on_parts {i in PARTS}:
      sum {j in PRODUCTS} NECESSARY[i,j]*NUMBER_TO_BUILD[j] <= INVENTORY[i];

