#########################################################################
#                                                                       #
# A soft-drink company has different plants that all require a certain  # 
# amount of sugar. There are different companies from whom sugar can be #
# bought. Where should the company buy the sugar and how much should it #
# buy, to minimize cost of sugar and shipping?                          #
#                                                                       #
#########################################################################

set PLANTS;
set COMPANIES;

##############
# Parameters #
##############

param SUGAR_PRICE {COMPANIES};                     # Price of sugar
param SHIPPING_COST {PLANTS,COMPANIES};            # Cost of shipping
param DEMAND {PLANTS};                             # Demand of plants
param SUPPLY {COMPANIES};                          # Supply at companies

#############
# Variables #
#############

var AMOUNT_TO_BUY {PLANTS,COMPANIES} >=0;          # Sugar to buy

#########
# Model #
#########

minimize TOTAL_COST:
   sum {i in PLANTS, j in COMPANIES} AMOUNT_TO_BUY[i,j]*
                                    (SHIPPING_COST[i,j]+SUGAR_PRICE[j]);
subject to
   Demand {i in PLANTS}:
      sum {j in COMPANIES} AMOUNT_TO_BUY[i,j] =DEMAND[i];
   Supply {j in COMPANIES}:
      sum {i in PLANTS} AMOUNT_TO_BUY[i,j] <= SUPPLY[j];

                                     

