###########################################################################
#                                                                         #
# A company wants to assign 14 employees to 10 offices. Each employee has #
# a preference for a certain office. How should the company assign        #
# employees to the offices to maximize the preference of all employees?   #
#                                                                         #
###########################################################################

set EMPLOYEES;
set OFFICES;

##############
# Parameters #
##############

param REQUIREMENTS {OFFICES};                   # Employees required in office
param CHOICE {EMPLOYEES,OFFICES};               # Preference of employees

#############
# Variables #
#############

var ASSIGNMENTS {EMPLOYEES,OFFICES} binary;     # Assignments to offices

#########
# Model #
#########

minimize TOTAL_CHOICE:
   sum {i in EMPLOYEES, j in OFFICES} CHOICE[i,j]*ASSIGNMENTS[i,j];
subject to
   Requirements {j in OFFICES}:
      sum {i in EMPLOYEES} ASSIGNMENTS[i,j] = REQUIREMENTS[j];
   One_assignment_per_employee {i in EMPLOYEES}:
      sum {j in OFFICES} ASSIGNMENTS[i,j] = 1;

