###########################################################################
#                                                                         #
# For employees working five consecutive days with two days off, find the #
# schedule which meets the minimum required attendance level demand while #
# minimizing payroll costs.                                               #
#                                                                         #
###########################################################################

set SCHEDULES;
set DAYS;

##############
# Parameters #
##############

param DEMAND {DAYS};                    # Employees required per day
param WORKING_DAYS {SCHEDULES,DAYS};    # Working days per week per schedule
param PAY_PER_EMPLOYEE_PER_WEEK;        # Weekly salary

#############
# Variables #
#############

var EMPLOYEES {SCHEDULES} integer, >=0; # Number of employees per schedule 

#########
# Model #
#########

minimize COST:
   PAY_PER_EMPLOYEE_PER_WEEK*sum {i in SCHEDULES} EMPLOYEES[i];
subject to
   Required {j in DAYS}:
      sum {i in SCHEDULES} EMPLOYEES[i]*WORKING_DAYS[i,j] >= DEMAND[j];

