#########################################################################
#                                                                       #
# An army wants to move troops from several training camps to different #
# bases. How should the troops be moved to minimize cost?               #
#                                                                       #
#########################################################################

set BASES;
set CAMPS;

##############
# Parameters #
##############

param MOVING_COST {CAMPS,BASES};                 # Cost per man
param AVAILABLE {CAMPS};                         # Available men per camp
param REQUIRED {BASES};                          # Required men per camp

#############
# Variables #
#############

var TROOPS_MOVED {CAMPS,BASES} >=0;              # Men moved from camp to base

#########
# Model #
#########

minimize COST:
   sum {i in CAMPS,j in BASES} TROOPS_MOVED[i,j]*MOVING_COST[i,j];
subject to
   Requirements {j in BASES}:
      sum {i in CAMPS} TROOPS_MOVED[i,j] = REQUIRED[j];
   Available {i in CAMPS}:
      sum {j in BASES} TROOPS_MOVED[i,j] <= AVAILABLE[i];

